/* $Id: Comment.c,v 1.5 2008/06/12 00:42:01 arpruss Exp $ */
#include <PalmOS.h>
#include "Backup.h"



Char* PathAppend( Char* path, Char* name )
{
    Char* p;

    p = MemPtrNew( StrLen( path ) + StrLen( name ) + 1 );

    if ( p != NULL )
        StrPrintF( p, "%s/%s", path, name );

    return p;
}


void GetComment( Char* path )
{
    FileRef ref;
    Char*   name;
    UInt32  didRead;

    *comment = 0;

    name = PathAppend( path, commentName );

    if ( name == NULL )
        return;
        
    if ( errNone != VFSFileOpen( curCardVol, name, vfsModeRead, &ref ) ) {
        SafeMemPtrFree( name );
        name = PathAppend( path, oldCommentName );
        if ( errNone != VFSFileOpen( curCardVol, name, vfsModeRead, &ref ) ) {
            SafeMemPtrFree( name );
            return;
        }
    }

    didRead = 0;
    VFSFileRead( ref, MAX_COMMENT_SIZE, comment, &didRead );
    VFSFileClose( ref );
    SafeMemPtrFree( name );

    comment[ didRead ] = 0;
}



Boolean Handler_frmComment( EventType* event )
{
    Boolean handled;

    handled = false;

    switch (event->eType) {
        case frmOpenEvent: {
            EventType e;

            Show( lblBackup1, afterComment == BACKUP );
            Show( lblBackup2, afterComment == BACKUP );

            if ( afterComment == SAVE_COMMENT || afterComment == NOOP )
                CtlSetLabel( GetObjectPtr( btnContinue ), "OK" );
            else
                CtlSetLabel( GetObjectPtr( btnContinue ), "Continue" );

            SetField( fldComment, *comment ? ( comment + 1 ) : "" );
            SetValue( chkAuto, *comment == '1' );
            FldSetSelection( GetObjectPtr( fldComment ), 0, 0xFFFF );
            FrmDrawForm( FrmGetActiveForm() );
            FrmSetFocus( FrmGetActiveForm(), GetObjectIndex( fldComment ) );
            FldGrabFocus( GetObjectPtr( fldComment ) );

            MemZero( &e, sizeof( EventType ) );
            e.eType = frmObjectFocusTakeEvent;
            e.data.frmObjectFocusTake.formID = FrmGetActiveFormID();
            e.data.frmObjectFocusTake.objectID = fldComment;
            EvtAddEventToQueue( &e );

            handled = true;
            break;
        }

//        case keyDownEvent:
//            handled = FldHandleEvent( GetObjectPtr( fldComment ), event );
//            break;

        case ctlSelectEvent:
            switch( event->data.ctlEnter.controlID ) {
                case btnContinue:
                    CopyFromField( comment + 1, fldComment, MAX_COMMENT_SIZE - 1 );
                    comment[ 0 ] = '0' + !! GetValue( chkAuto );
                    nextAction = afterComment;
                    nextActionArgument = afterCommentArgument;
                    FrmReturnToForm( 0 );
                    handled = true;
                    break;
                case btnCancel:
                    afterComment = NOOP;
                    FrmReturnToForm( 0 );
                    handled = true;
                    break;
            }
            break;

        default:
            break;
    }
    return handled;
}




